<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<!-- namespace必须指向Dao接口 -->
<mapper namespace="OrdersPO">
    <!-- result Map -->
    <resultMap id="resultMap"
               type="com.sunxd.study.sharding.jdbc.po.OrdersPO">
        <result property="id" column="id"/>
        <result property="shopId" column="shopId"/>
        <result property="userId" column="userId"/>
        <result property="creator" column="creator"/>
        <result property="createTime" column="create_time"/>
        <result property="updater" column="updater"/>
        <result property="updateTime" column="update_time"/>
        <result property="deleteFlag" column="delete_flag"/>
    </resultMap>

    <!-- 用于select查询公用抽取的列 -->
    <sql id="table">t_orders</sql>

    <sql id="cols_all">
        id,
        <include refid="cols_exclude_id"/>
    </sql>

    <sql id="cols_exclude_id">
        shopId,userId,
        creator,create_time,updater,update_time,delete_flag
    </sql>

    <!-- insert cols 主键id自增不显示赋值 -->
    <sql id="insert_cols">
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="shopId != null">shopId,</if>
            <if test="userId != null">userId,</if>
            <if test="creator != null and creator != 'null' and creator != ''">creator,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updater != null and updater != 'null' and updater != ''">updater,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="deleteFlag != null">delete_flag</if>
        </trim>
    </sql>

    <!-- 插入字段值，与 insert_cols 配套使用 -->
    <sql id="insert_vals">
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="shopId != null">#{shopId},</if>
            <if test="userId != null">#{userId},</if>
            <if test="creator != null and creator != 'null' and creator != ''">#{creator},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updater != null and updater != 'null' and updater != ''">#{updater},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="deleteFlag != null">#{deleteFlag}</if>
        </trim>
    </sql>


    <!-- 创建活动 -->
    <insert id="create"
            parameterType="com.sunxd.study.sharding.jdbc.po.OrdersPO"
            keyProperty="id" useGeneratedKeys="true">
        INSERT INTO
        <include refid="table"/>
        <include refid="insert_cols"/>
        <include refid="insert_vals"/>
    </insert>


</mapper>
